## ros-kinetic-soem 1.4.1000

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(soem)

find_package(catkin REQUIRED)

message([=[
        
          SOEM ROS Package Upgrade Announcement
          =====================================
          
          Prior, due to the code layout in soem, a workaround
          has been necessary in users of this library.
          This version solves this issue now by
          providing proper cmake configuration files.
          
          If you've used the workaround of specifying
          `${soem_INCLUDE_DIRS}/soem` in the include_directories section
          in your code/library, you should remove this now.
          
          Also, this package has been upgraded to the upstream
          SOEM release 1.4.0.
          If you experience any problems, you can revert to
          release v1.3.0 of this package to retrieve the old state.
        ]=]
       )

# set-up destination variables
catkin_destinations()

# create directory during CMake build system creation step
file(MAKE_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_INCLUDE_DESTINATION})

if(WIN32)
  set(OS "win32")
else()
  set(OS "linux")
endif()

file(GLOB SOEM_COMMON_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/SOEM/soem/*.h")
file(GLOB SOEM_OSAL_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/SOEM/osal/${OS}/*.h")
file(GLOB SOEM_OSHW_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/SOEM/oshw/${OS}/*.h")

# Copy header to ROS-standard location in devel space to satisfy catkin_package
add_custom_target(CopyHeaders ALL
                  COMMAND ${CMAKE_COMMAND} -E copy_if_different
                          ${SOEM_COMMON_HEADERS}
                          ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_INCLUDE_DESTINATION}
                  COMMAND ${CMAKE_COMMAND} -E copy_if_different
                          ${CMAKE_CURRENT_SOURCE_DIR}/SOEM/osal/osal.h
                          ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_INCLUDE_DESTINATION}
                  COMMAND ${CMAKE_COMMAND} -E copy_if_different
                          ${SOEM_OSAL_HEADERS}
                          ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_INCLUDE_DESTINATION}
                  COMMAND ${CMAKE_COMMAND} -E copy_if_different
                          ${SOEM_OSHW_HEADERS}
                          ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_INCLUDE_DESTINATION}
                  COMMENT "Copying SOEM headers to ROS-standard in devel space location.")

if(WIN32)
  add_custom_target(CopyWpcapHeaders ALL
                  COMMAND ${CMAKE_COMMAND} -E copy_directory
                          ${CMAKE_CURRENT_SOURCE_DIR}/SOEM/oshw/${OS}/wpcap/Include/
                          ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_INCLUDE_DESTINATION}
                  COMMENT "Copying Wpcap headers to ROS-standard in devel space location.")
endif()

# explicitely find pthread to be able to explicitely export the pthread dependency via catkin_package
# see https://github.com/ros/ros_comm/issues/135
set(PTHREAD_LIB "")
find_package(Threads)
if(CMAKE_THREAD_LIBS_INIT)
  string(LENGTH ${CMAKE_THREAD_LIBS_INIT} _length)
  if(_length GREATER 2)
    string(SUBSTRING ${CMAKE_THREAD_LIBS_INIT} 0 2 _prefix)
    if(${_prefix} STREQUAL "-l")
      math(EXPR _rest_len "${_length} - 2")
      string(SUBSTRING ${CMAKE_THREAD_LIBS_INIT} 2 ${_rest_len} PTHREAD_LIB)
    endif()
  endif()
endif()

# export dependencies and targets to catkin
# explicitely export pthread, as stated above
catkin_package(
  CFG_EXTRAS soem-ros-extras.cmake
  LIBRARIES soem ${PTHREAD_LIB}
)

# SOEM is, by default, built with position-dependent code as a static library.
# To be able to include SOEM in a dynamic library (default ROS convention),
# it needs to be built with position-independent code.
# Thus, we add -fPIC here.
# This allows us to still include this in any shared libraries we create.
add_compile_options(-fPIC)
# removed any pre-defined `WIN32_LEAN_AND_MEAN`.
# Otherwise, many symbols will be reported as missing.
remove_definitions(-DWIN32_LEAN_AND_MEAN)
#catkin_lint: ignore duplicate_cmd
#catkin_lint: ignore subproject
add_subdirectory(SOEM)

=== SOEM/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.4)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules")
project(SOEM C)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  # Default to installing in SOEM source directory
  set(CMAKE_INSTALL_PREFIX ${CMAKE_SOURCE_DIR}/install)
endif()

set(SOEM_INCLUDE_INSTALL_DIR include/soem)
set(SOEM_LIB_INSTALL_DIR lib)
set(BUILD_TESTS TRUE)

if(WIN32)
  set(OS "win32")
  include_directories(oshw/win32/wpcap/Include)
  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    link_directories(oshw/win32/wpcap/Lib/x64)
  elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
    link_directories(oshw/win32/wpcap/Lib)
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /D _CRT_SECURE_NO_WARNINGS")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  /WX")
  set(OS_LIBS wpcap.lib Packet.lib Ws2_32.lib Winmm.lib)
elseif(UNIX AND NOT APPLE)
  set(OS "linux")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Werror")
  set(OS_LIBS pthread rt)
elseif(APPLE)
  # This must come *before* linux or MacOSX will identify as Unix.
  set(OS "macosx")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Werror")
  set(OS_LIBS pthread pcap)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "rt-kernel")
  set(OS "rtk")
  message("ARCH is ${ARCH}")
  message("BSP is ${BSP}")
  include_directories(oshw/${OS}/${ARCH})
  file(GLOB OSHW_EXTRA_SOURCES oshw/${OS}/${ARCH}/*.c)
  set(OSHW_SOURCES "${OS_HW_SOURCES} ${OSHW_ARCHSOURCES}")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Werror")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-but-set-variable")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-function")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-format")
  set(OS_LIBS "-Wl,--start-group -l${BSP} -l${ARCH} -lkern -ldev -lsio -lblock -lfs -lusb -llwip -leth -li2c -lrtc -lcan -lnand -lspi -lnor -lpwm -ladc -ltrace -lc -lm -Wl,--end-group")
elseif(${CMAKE_SYSTEM_NAME} MATCHES "rtems")
  message("Building for RTEMS")
  set(OS "rtems")
  set(SOEM_LIB_INSTALL_DIR ${LIB_DIR})
  set(BUILD_TESTS FALSE)
endif()

message("OS is ${OS}")

file(GLOB SOEM_SOURCES soem/*.c)
file(GLOB OSAL_SOURCES osal/${OS}/*.c)
file(GLOB OSHW_SOURCES oshw/${OS}/*.c)

file(GLOB SOEM_HEADERS soem/*.h)
file(GLOB OSAL_HEADERS osal/osal.h osal/${OS}/*.h)
file(GLOB OSHW_HEADERS oshw/${OS}/*.h)

include_directories(soem)
include_directories(osal)
include_directories(osal/${OS})
include_directories(oshw/${OS})

add_library(soem STATIC
  ${SOEM_SOURCES}
  ${OSAL_SOURCES}
  ${OSHW_SOURCES}
  ${OSHW_EXTRA_SOURCES})
target_link_libraries(soem ${OS_LIBS})

message("LIB_DIR: ${SOEM_LIB_INSTALL_DIR}")

install(TARGETS soem DESTINATION ${SOEM_LIB_INSTALL_DIR})
install(FILES
  ${SOEM_HEADERS}
  ${OSAL_HEADERS}
  ${OSHW_HEADERS}
  DESTINATION ${SOEM_INCLUDE_INSTALL_DIR})

if(BUILD_TESTS) 
  add_subdirectory(test/linux/slaveinfo)
  add_subdirectory(test/linux/eepromtool)
  add_subdirectory(test/linux/simple_test)
endif()

=== debian/changelog ===
ros-kinetic-soem (1.4.1000-1xenial) xenial; urgency=high

  * fix formatting of README
  * remove stale bot
  * change version number policy and bump to 1.4.1000
  * bump cmake_minimum to 3.0.2
  * Merge pull request #33 <https://github.com/mgruhler/soem/issues/33> from seanyen/windows
    [master] Enable Windows build.
  * undef WIN32_LEAN_AND_MEAN instead of touching SOEM code.
  * Enable Windows build.
  * Contributors: Matthias Gruhler, seanyen

 -- Matthias Gruhler <matthias.gruhler@gmail.com>  Thu, 18 Jun 2020 22:00:00 -0000

ros-kinetic-soem (1.4.0-1xenial) xenial; urgency=high

  * Merge pull request #24 <https://github.com/mgruhler/soem/issues/24> from mgruhler/upstream_soem_via_subtree
    Upstream soem release 1.4.0 via subtree
  * explicitely export pthread dependency, reported in #30 <https://github.com/mgruhler/soem/issues/30>
  * install all headers in osal and oshw
  * fixes #29 <https://github.com/mgruhler/soem/issues/29>: provides issue templates
    provides three templates
    - bug report
    - feature request
    - question
  * fixes #28 <https://github.com/mgruhler/soem/issues/28>: adds note about ethercat_grant to README
  * fix readme justification
  * Merge branch 'master' into upstream_soem_via_subtree
  * Merge pull request #25 <https://github.com/mgruhler/soem/issues/25> from mgruhler/upgrade_announcement
    add upgrade announcement
  * add upgrade announcement
  * change deprecation message
    * switch from type DEPRECATION to type <none>
    * minor formatting and typo fixes
  * make new integration backwards compatible
    - add deprecation warning of workaround to CMakeLists.txt
    - change order of include directories in cfg extras file
  * restore version number and relevant package.xml contents
  * update docs
    * fix description in package.xml
    * update README
  * setup ROS build instructions for upstream SOEM as subtree
    - add new package.xml and CMakeLists.txt
    - add -fPIC definition and comment ROS specific "hacks"
    - copy headers to develspace instead of src space
    - provide cmake extras file to set include directories
    - fix cmake_minimum_required for using add_compile_options
    - ignore catkin_lint errors for SOEM CMakeLists.txt
  * Merge commit 'd471a3878b20d650a6d80a487625324392a23906' as 'SOEM'
  * Squashed 'SOEM/' content from commit abbf0d4
    git-subtree-dir: SOEM
    git-subtree-split: abbf0d42e38d6cfbaa4c1e9e8e07ace651c386fd
  * remove old SOEM state
  * State release into ROS melodic in README.md
  * Add close comment and extend daysUntilClose in stale.yaml
  * Update README.md: clarify Usage section
    add note to either use from apt or followed development section
  * add stale.yml for Stale Probot
  * add README.md:
    * clarifying what this package is about
    * adding sections about installation, usage and development
  * update description in package.xml
    - more explicitely explain what this package is about
    - link more directly to upstream by noting what this is actually based upon
  * update description and URLs in package.xml
  * update maintainer

 -- Matthias Gruhler <matthias.gruhler@gmail.com>  Wed, 18 Sep 2019 22:00:00 -0000

ros-kinetic-soem (1.3.0-1xenial) xenial; urgency=high

  * Update soem version number
    Signed-off-by: Ruben Smits <mailto:ruben.smits@intermodalics.eu>
  * cmake: remove erroneous linking to pq
    Signed-off-by: Ruben Smits <mailto:ruben.smits@intermodalics.eu>
  * cmake: use non-capitalised project name in cmake config file
    Signed-off-by: Ruben Smits <mailto:ruben.smits@intermodalics.eu>
  * Merge pull request #3 <https://github.com/mgruhler/soem/issues/3> from meyerj/cmake-fixes
    Some more cmake fixes required for installation
  * osal: added missing header installation
  * cmake: fixed exported cmake config
  * Merge pull request #1 <https://github.com/mgruhler/soem/issues/1> from meyerj/patch-1
    Fixed header installation in oshw
  * Fixed header installation in oshw
  * add missing CMakeLists.txt for oshw dir
    Signed-off-by: Ruben Smits <mailto:ruben.smits@intermodalics.eu>
  * finalized cmake build system for 1.3.0
    Signed-off-by: Ruben Smits <mailto:ruben.smits@intermodalics.eu>
  * Import upstream release 1.3.0
    Signed-off-by: Ruben Smits <mailto:ruben.smits@intermodalics.eu>
  * move src to soem directory to prepare 1.3.0 upgrade
    Signed-off-by: Ruben Smits <mailto:ruben.smits@intermodalics.eu>
  * Added install rule for package.xml
    Signed-off-by: Ruben Smits <mailto:ruben.smits@intermodalics.eu>

 -- Ruben Smits <ruben@intermodalics.eu>  Sun, 25 Jan 2015 23:00:00 -0000

ros-kinetic-soem (1.2.5-1xenial) xenial; urgency=high

  * add cmake build system
    Signed-off-by: Ruben Smits <mailto:ruben.smits@intermodalics.eu>
  * Upstream SOEM 1.2.5
    Signed-off-by: Ruben Smits <mailto:ruben.smits@intermodalics.eu>
  * Contributors: Johannes Meyer, Matthias Gruhler, Ruben Smits

 -- Matthias Gruhler <matthias.gruhler@gmail.com>  Tue, 05 Mar 2013 23:00:00 -0000

=== debian/control ===
Source: ros-kinetic-soem
Section: misc
Priority: optional
Maintainer: Matthias Gruhler <matthias.gruhler@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-catkin
Homepage: http://openethercatsociety.github.io/
Standards-Version: 3.9.2

Package: ros-kinetic-soem
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
Description: ROS wrapper for the Simple Open EtherCAT Master SOEM.
 This is an updated version of the original SOEM wrapper released into ROS now including the upstream Repo as a git subtree.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-soem//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
